## AS+AT the ray
# Main function that performing the
# ray cast / trace and evaluating the results
# process (hit: string)

# Step size: 0.25
# Set max steps: = player.entity_interaction_range * 4, so the
# ray only goes as far as the players entity interaction range + some extra
execute store result score @s villager_stats.ray_step run attribute @p player.entity_interaction_range base get 5

# Broadcast the ray's villager_stats.ray_step scoreboard (max step size) to the player. Uncomment for debugging.
#tellraw @a [{"text": "[Marker] max ray steps: "},{"score": {"name": "@s", "objective": "villager_stats.ray_step"}}]

# Call move function
execute as @s at @s run function villager_stats:impl/raycast/move

# Check if a villager was found
$execute as @s[tag=villager_stats.hit] at @s positioned ~-0.05 ~-0.05 ~-0.05 as @e[type=villager,dx=0.1,dy=0.1,dz=0.1,sort=nearest,limit=1] run $(hit)
# ... otherwise
execute as @s[tag=!villager_stats.hit] run function villager_stats:impl/raycast/miss with storage villager_stats:temp data

# Remove ray
kill @s
