## AS+AT the ray (marker)
# Move the marker/ray by one step

# Moves the marker/ray by 0.25 blocks in the direction it's facing
tp @s ^ ^ ^0.25

# Visualise with a particle (uncomment for debugging)
#particle flame ~ ~ ~ 0 0 0 0 1 force

# Check for villagers
execute at @s positioned ~-0.05 ~-0.05 ~-0.05 if entity @e[type=villager,dx=0.1,dy=0.1,dz=0.1] run tag @s add villager_stats.hit

# Decrement amount of remaining steps
scoreboard players remove @s villager_stats.ray_step 1

# Proceed under the right conditions
execute as @s[tag=!villager_stats.hit,scores={villager_stats.ray_step=1..}] if block ~ ~ ~ #villager_stats:raycast_permeable at @s run function villager_stats:impl/raycast/move
